<?php
error_reporting(E_ALL);

if (file_exists(dirname(__FILE__) . '/SSI.php') && !defined('SMF'))
{
	$using_ssi = true;
	require_once(dirname(__FILE__) . '/SSI.php');
	db_extend('packages');
}
elseif (!defined('SMF'))
	exit('<b>Error:</b> Cannot install - please verify you put this file in the same place as SMF\'s SSI.php.');

global $db_prefix, $modSettings, $func, $smcFunc, $sourcedir;


// First insert the column...
$smcFunc['db_add_column']($db_prefix . 'members', array('name' => 'banned_until', 'type' => 'int', 'size' => 10, 'unsigned' => true, 'null' => true, 'default' => 0));

/*
Now actually cause it to be synced. Unfortunately, we can't simply call
updateBanMembers(), since we can't trust that ManageBans.php was updated yet.
*/
$allMembers = array();
$banned_until_updates = array();

// Start by getting all active bans
$request = $smcFunc['db_query']('', '
	SELECT bi.id_member, bi.email_address, bg.expire_time
	FROM {db_prefix}ban_items AS bi
		INNER JOIN {db_prefix}ban_groups AS bg ON (bg.id_ban_group = bi.id_ban_group)
	WHERE (bi.id_member > {int:no_member} OR bi.email_address != {string:blank_string})
		AND (bg.cannot_access = {int:cannot_access_on} OR bg.cannot_post = {int:cannot_post_on} OR bg.cannot_login = {int:cannot_login_on})
		AND (bg.expire_time IS NULL OR bg.expire_time > {int:current_time})',
	array(
		'no_member' => 0,
		'cannot_access_on' => 1,
		'cannot_post_on' => 1,
		'cannot_login_on' => 1,
		'current_time' => time(),
		'blank_string' => '',
	)
);
/*
$member* arrays contain all types of bans (except "cannot register" of
course), because all these types of bans should be displayed to users.
$member*Expiry arrays contain the maximum expiry timestamps that apply to
the ban triggers.
*/
$memberIDs = array();
$memberEmails = array();
$memberEmailWild = array();
$memberIDsExpiry = array();
$memberEmailsExpiry = array();
$memberEmailWildExpiry = array();
while ($row = $smcFunc['db_fetch_assoc']($request))
{
	if ($row['id_member'])
	{
		$memberIDs[$row['id_member']] = $row['id_member'];

		// When does this expire?
		if (!array_key_exists($row['id_member'], $memberIDsExpiry) || $row['expire_time'] === NULL || ($memberIDsExpiry[$row['id_member']] !== NULL && $row['expire_time'] > $memberIDsExpiry[$row['id_member']]))
			$memberIDsExpiry[$row['id_member']] = $row['expire_time'];
	}
	if ($row['email_address'])
	{
		// Does it have a wildcard - if so we can't do a IN on it.
		if (strpos($row['email_address'], '%') !== false)
		{
			$memberEmailWild[$row['email_address']] = $row['email_address'];
			$expiryArrayPtr = &$memberEmailWildExpiry;
		}
		else
		{
			$memberEmails[$row['email_address']] = $row['email_address'];
			$expiryArrayPtr = &$memberEmailsExpiry;
		}

		// When does this expire?
		if (!array_key_exists($row['email_address'], $expiryArrayPtr) || $row['expire_time'] === NULL || ($expiryArrayPtr[$row['email_address']] !== NULL && $row['expire_time'] > $expiryArrayPtr[$row['email_address']]))
			$expiryArrayPtr[$row['email_address']] = $row['expire_time'];
	}
}
$smcFunc['db_free_result']($request);

// Build up the query.
$queryPart = array();
$queryValues = array();
if (!empty($memberIDs))
{
	$queryPart[] = 'mem.id_member IN ({array_int:member_ids})';
	$queryValues['member_ids'] = $memberIDs;
}
if (!empty($memberEmails))
{
	$queryPart[] = 'mem.email_address IN ({array_string:member_emails})';
	$queryValues['member_emails'] = $memberEmails;
}
$count = 0;
foreach ($memberEmailWild as $email)
{
	$queryPart[] = 'mem.email_address LIKE {string:wild_' . $count . '}';
	$queryValues['wild_' . $count++] = $email;
}

// Find all banned members.
if (!empty($queryPart))
{
	$request = $smcFunc['db_query']('', '
		SELECT mem.id_member, mem.email_address, mem.banned_until
		FROM {db_prefix}members AS mem
		WHERE ' . implode( ' OR ', $queryPart),
		$queryValues
	);
	while ($row = $smcFunc['db_fetch_assoc']($request))
	{
		if (!in_array($row['id_member'], $allMembers))
		{
			$allMembers[] = $row['id_member'];
			// So... When will all of your bans have expired?
			$banTimes = array();
			if (array_key_exists($row['id_member'], $memberIDsExpiry))
				$banTimes[] = $memberIDsExpiry[$row['id_member']];
			if (array_key_exists($row['email_address'], $memberEmailsExpiry))
				$banTimes[] = $memberEmailsExpiry[$row['email_address']];
			foreach ($memberEmailWildExpiry as $email => $expires)
			{
				// A little more tricky, but nothing PHP can't handle.
				// First check if we're not wasting time checking more!
				if (in_array(NULL, $banTimes))
					break;
				$pattern = '/^' . str_replace('%', '.*?', preg_quote($email)) . '$/i';
				if (preg_match($pattern, $row['email_address']))
					$banTimes[] = $expires;
			}
			if (in_array(NULL, $banTimes))
			{
				if ($row['banned_until'] !== NULL)
					$banned_until_updates['NULL'][] = $row['id_member'];
			}
			else
			{
				$maxBanTime = max($banTimes);
				if ($row['banned_until'] != $maxBanTime)
					$banned_until_updates[$maxBanTime][] = $row['id_member'];
			}
		}
	}
	$smcFunc['db_free_result']($request);
}

// For some reason, passing an empty array to the database is an error.
$queryMemberIn = '';
$queryValues = array(
	'current_time' => time(),
);
if (!empty($allMembers))
{
	$queryMemberIn = '
		AND mem.id_member NOT IN ({array_int:all_members})';
	$queryValues['all_members'] = $allMembers;
}
// Are there any members with a banned label while they're not banned?
$request = $smcFunc['db_query']('', '
	SELECT mem.id_member
	FROM {db_prefix}members AS mem
	WHERE (mem.banned_until IS NULL OR mem.banned_until > {int:current_time})' . $queryMemberIn,
	$queryValues
);
while ($row = $smcFunc['db_fetch_assoc']($request))
{
	$banned_until_updates[0][] = $row['id_member'];
}
$smcFunc['db_free_result']($request);

foreach ($banned_until_updates as $newTime => $members)
{
	// Once again, we can't use a newly modified function yet
	$smcFunc['db_query']('', '
		UPDATE {db_prefix}members
		SET banned_until = {raw:p_banned_until}
		WHERE id_member IN ({array_int:members})',
		array(
			'members' => $members,
			'p_banned_until' => $newTime
		)
	);

	// Maybe we're caching everything
	if (!empty($modSettings['cache_enable']) && $modSettings['cache_enable'] >= 3 && !empty($members))
	{
		foreach ($members as $member)
		{
			cache_put_data('member_data-profile-' . $member, null, 120);
			cache_put_data('member_data-normal-' . $member, null, 120);
		}
	}
}


if(!empty($using_ssi))
	echo 'Done';
